/* Ce client UDP : 
  1/ prend en parametre une adresse IP (exemple d'utilisation : ./client_udp 127.0.0.1)
  2/ envoie un paquet UDP avec le mot "request" a un serveur ecoutant sur le port 3000 et sur l'adresse indiquee en parametre
  3/ lit la reponse , affiche celle ci , avec le port et l'adresse de l'emetteur de la reponse 
*/

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

/* definition des constantes */
#define MAXLINE 1024

int main(int argc, char *argv[])
{
	int sockClient, sockServer;
	int  nread, nsend;
	struct sockaddr_in addrServer, addrClient;
	char buffer[MAXLINE+1];
	int windowNumber;
	int nbWindows;
	int portDest;

	if (argc < 4){
		printf("Usage: chenille addresse windowNumber nbWindows\n");
	}
	windowNumber = atoi(argv[2]);
	nbWindows = atoi(argv[3]);

	/* SOCKET creation de socket */
	if ( (sockServer = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
	{
		perror("Socket creation error");
		return -1;
	}
	
	if ( (sockClient = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
	{
		perror("Socket creation error");
		return -1;
	}
     
	/* SEND initialiser l’adresse du serveur  */
	/* type d’adresse  INET */
	addrServer.sin_family = AF_INET;
	addrServer.sin_port = htons(3000+windowNumber);
	
	/* contruction d’adresse IP binaire avec inet_pton */
	/* l’adresse est donnee en argument « x.x.x.x » */
	if((inet_pton(AF_INET,argv[1],&addrServer.sin_addr)) <= 0) {
		perror("Address creation error");
		return -1;
	}
	bzero(addrServer.sin_zero, 8);
	
	addrClient.sin_family = AF_INET;
	portDest = (3000+windowNumber+1 > 3000+nbWindows-1) ? 3000 : 3000+windowNumber+1;
	addrClient.sin_port = htons(portDest);

	/* contruction d’adresse IP binaire avec inet_pton */
	/* l’adresse est donnee en argument « x.x.x.x » */
	if((inet_pton(AF_INET,argv[1],&addrClient.sin_addr)) <= 0) {
		perror("Address creation error");
		return -1;
	}
	bzero(addrClient.sin_zero, 8);

	bind(sockServer, (struct sockaddr *) &addrServer, sizeof(addrServer));
	
	// Met l'ecran en rouge	
	printf ("\033[41m\n");
	system("clear");        
	
	if (windowNumber == 0){
		// Affiche tout l'écran en vert
		printf ("\033[42m\n");
		system("clear");		
		sleep(1);
		// Met l'ecran en rouge	
		printf ("\033[41m\n");
		system("clear");		
		nsend = sendto(sockClient, "toYou", 5, 0, (struct sockaddr *)&addrClient, sizeof(addrClient));
		if (nsend < 0) {
			perror("Request error");
			return -1;
		}
	}
	
	/* RECEIVE lecture de la reponse */
	struct sockaddr_in from;
	unsigned int fromlen = sizeof(from);
     
	while (1) {	
		nread = recvfrom(sockServer, buffer, MAXLINE, 0, (struct sockaddr *) &from,&fromlen);
	    	if (nread < 0) {
			perror("Read error");
			return -1;
	   	}
		// Affiche tout l'écran en vert
		printf ("\033[42m\n");
		system("clear");		
		sleep(1);
		// Met l'ecran en rouge	
		printf ("\033[41m\n");
		system("clear");
		nsend = sendto(sockClient, "toYou", 5, 0, (struct sockaddr *)&addrClient, sizeof(addrClient));
		if (nsend < 0) {
			perror("Request error");
			return -1;
		}
	}
     
	return 0;
     
}
