/* Ce client UDP : 
  1/ prend en parametre une adresse IP (exemple d'utilisation : ./client_udp 127.0.0.1)
  2/ envoie un paquet UDP avec le mot "request" a un serveur ecoutant sur le port 3000 et sur l'adresse indiquee en parametre
  3/ lit la reponse , affiche celle ci , avec le port et l'adresse de l'emetteur de la reponse 
*/

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

/* definition des constantes */
#define MAXLINE 1024

int main(int argc, char *argv[])
{
	int sock;
	int  nread, nsend;
	struct sockaddr_in addr;
	char buffer[MAXLINE+1];

	/* SOCKET creation de socket */
	if ( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
	{
		perror("Socket creation error");
		return -1;
	}
	
     
	/* SEND initialiser l’adresse du serveur  */
	/* type d’adresse  INET */
	addr.sin_family = AF_INET;
	addr.sin_port = htons(3000);
	

	/* contruction d’adresse IP binaire avec inet_pton */
	/* l’adresse est donnee en argument « x.x.x.x » */
	if((inet_pton(AF_INET,argv[1],&addr.sin_addr)) <= 0) {
		perror("Address creation error");
		return -1;
	}
	bzero(addr.sin_zero, 8);
	
	// Met l'ecran en rouge	
	printf ("\033[41m\n");
	system("clear");      
	if (argc == 3 && strcmp(argv[2], "last")==0)	
		nsend = sendto(sock, "last", 4, 0, (struct sockaddr *)&addr, sizeof(addr));
	else
		nsend = sendto(sock, "hello", 5, 0, (struct sockaddr *)&addr, sizeof(addr));
	if (nsend < 0) {
		perror("Request error");
		return -1;
	}
	
	/* RECEIVE lecture de la reponse */
	struct sockaddr_in from;
	unsigned int fromlen = sizeof(from);
     
	while (1) {	
		nread = recvfrom(sock, buffer, MAXLINE, 0, (struct sockaddr *) &from,&fromlen);
	    	if (nread < 0) {
			perror("Read error");
			return -1;
	   	}
		buffer[nread]='\0';
		if (strcmp(buffer, "die")==0){
			printf("Je meurt !\n");
			return 0;
		}
		// Affiche tout l'écran en vert
		printf ("\033[42m\n");
		system("clear");		
		sleep(1);
		// Met l'ecran en rouge	
		printf ("\033[41m\n");
		system("clear");
	}
     
	return 0;
     
}
