/* Ce client UDP : 
  1/ prend en parametre une adresse IP (exemple d'utilisation : ./client_udp 127.0.0.1)
  2/ envoie un paquet UDP avec le mot "request" a un serveur ecoutant sur le port 3000 et sur l'adresse indiquee en parametre
  3/ lit la reponse , affiche celle ci , avec le port et l'adresse de l'emetteur de la reponse 
*/

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/* definition des constantes */
#define MAXLINE 1024

int main(int argc, char *argv[])
{
     int sock;
     int  nread, nsend;
     struct sockaddr_in addr;
     char buffer[MAXLINE+1];

     /* SOCKET creation de socket */
     if ( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
     {
         perror("Socket creation error");
         return -1;
     }
     
     /* SEND initialiser l’adresse du serveur  */
     /* type d’adresse  INET */
     addr.sin_family = AF_INET;
     addr.sin_port = htons(3000);
     
     /* contruction d’adresse IP binaire avec inet_pton */
     /* l’adresse est donnee en argument « x.x.x.x » */
     if((inet_pton(AF_INET,argv[1],&addr.sin_addr)) <= 0) {
         perror("Address creation error");
         return -1;
     }
     bzero(addr.sin_zero, 8);
     
     /* envoi d’un packet avec le mot request a l'interieur */
     nsend = sendto(sock, "request", 7, 0,
                  (struct sockaddr *)&addr, sizeof(addr));
     if (nsend < 0) {
         perror("Request error");
         return -1;
     }
     
     /* RECEIVE lecture de la reponse */
     struct sockaddr_in from;
     unsigned int fromlen = sizeof(from);
     nread = recvfrom(sock, buffer, MAXLINE, 0, (struct sockaddr *) &from,&fromlen);
     if (nread < 0) {
         perror("Read error");
         return -1;
     }
     
     /* affichage de la reponse */
     buffer[nread]='\0';
     printf("La reponse est %s \n",buffer);
     printf("La reponse provient du port  %d \n",ntohs(from.sin_port));
     printf("La reponse provient de l'adresse IP  %s \n",inet_ntoa(from.sin_addr));
     return 0;
     
}