/*
 * Ce fichier contient le code ncessaire  la gestion du clavier
 *
 * Pour plus d'information sur la gestion du clavier, voir
 * http://c.developpez.com/faq/?page=clavier_ecran
 */


#include <sys/time.h>
#include <termios.h>
#include <stdio.h>
#include <unistd.h>



void mode_raw(int activer);

int readKeyBoard();


/**
 * Boucle principale
 */
int main(void)
{

  // Initialisation du mode raw
  mode_raw(1);

  int touche = 0;

  while(1==1)
  {
        // lecture non bloquante d'une touche
        touche = readKeyBoard();

        // Interpretation des touches

        // La touche q est la touche de sortie du programme
        if (touche == 'q' || touche == 'Q')
        {
          break;
        }

      //
      if (touche == 'v' || touche == 'V')
        {
          //
          printf("Vous avez appuy sur V\r\n");
        }


      // Attente de 10 ms
      usleep(10000);
    }






  // Desactivation du mode raw
  mode_raw(0);

  //
  return 0;
}






/**
 * Lit de facon non bloquant une touche du clavier
 * Retourne -1 si il n'y a pas de touche dans le buffer
 * sinon retourne la valeur de la touche
 */
int readKeyBoard()
{
          struct timeval tv = { 0, 0 };
          fd_set readfds;

          FD_ZERO(&readfds);
          FD_SET(STDIN_FILENO, &readfds);

          if (select(STDIN_FILENO + 1, &readfds, NULL, NULL, &tv) == 1)
          {
                  return getchar();
          }
          else
          {
                  return -1;
          }
}


/**
 * Permet l'activation du mode raw sur une console Linux
 *
 */
void mode_raw(int activer)
{


    static struct termios cooked;
    static int raw_actif = 0;

    if (raw_actif == activer)
        return;

    if (activer)
    {
        struct termios raw;

        tcgetattr(STDIN_FILENO, &cooked);

        raw = cooked;
        cfmakeraw(&raw);
        tcsetattr(STDIN_FILENO, TCSANOW, &raw);
    }
    else
        tcsetattr(STDIN_FILENO, TCSANOW, &cooked);

    raw_actif = activer;

}