package exercice1;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.nio.charset.StandardCharsets;

public class Tcp {
	static final int defaultPort = 8080;
	static final String defaultHost = "127.0.0.1";
	
	protected int port;
	protected String host;
	protected Socket sck;
	protected ServerSocket srvSck;
	
	public Tcp() {
		this(Tcp.defaultHost, Tcp.defaultPort);
	}
	
	public Tcp(String host, int port){
		this.port = port;
		this.host = host;
	}
	
	public void exercice1(){
		try{
			sck = new Socket(this.host, this.port);
		}
		catch (Exception e){
			System.err.println("Impossible de créer un socket");
		}
		
		try{
			sck.getOutputStream().write(51);
		}
		catch (Exception e){
			System.err.println("Impossible d'ecrire");
		}
		try{
			sck.close();
		}
		catch(Exception e){
			System.err.println("Impossible de fermer la socket");
		}
	}
	
	public void exercice2(){
		try{
			srvSck = new ServerSocket(this.port);
		}
		catch (Exception e){
			System.err.println("Impossible de créer un socket ("+e+")");
		}
		
		try {
			sck = srvSck.accept();
		} catch (IOException e) {
			System.err.println("Impossible d'accepter la socket");
		}
		
		byte[] clientAddr = sck.getInetAddress().getAddress();
		ByteBuffer bf = ByteBuffer.allocate(2);
		byte[] clientPort = bf.putInt(sck.getPort()).array();
		
		bf.clear();
		bf = ByteBuffer.allocate(256);
		
		bf.put(clientAddr);
		bf.putChar(':');
		bf.put(clientPort);
		
		try{
			sck.getOutputStream().write(bf.array());
		}
		catch (Exception e){
			System.err.println("Impossible d'ecrire");
		}
		
	}
	
	public void exercice2Bis() throws Exception{
		System.out.println("Demarrage du serveur ...");
		
		ServerSocket socketEcoute = new ServerSocket();
		socketEcoute.bind(new InetSocketAddress(this.port));

		// Attente de la connexion d'un client
		System.out.println("Attente de la connexion du client ...");
		Socket socketConnexion = socketEcoute.accept();
		System.out.println("Connexion établie");
		// Un client s'est connecte, le serveur lit le message envoye par le le client (sans garantie de lire tout le message)
		byte[] bufR = new byte[2048];
		InputStream is = socketConnexion.getInputStream();
		int lenBufR = is.read(bufR);
		String message = new String(bufR, 0 , lenBufR);
		System.out.println("Message recu = "+message);
		
		
		System.out.println("IP :"+ socketConnexion.getInetAddress().getHostAddress());
		System.out.println("Port :"+socketConnexion.getPort());
		
		socketEcoute.close();
		System.out.println("Arret du serveur .");
	}
	
	public void exercice3(String src, String dest){
		try {
			FileInputStream fis = new FileInputStream(new File(src));
			
			try {
				FileOutputStream fos = new FileOutputStream(new File(dest));
				int data;
				try {
					data = fis.read();
					while ( data != -1){
						fos.write(data);
						data = fis.read();
					}
					fis.close();
					fos.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
	}
}
