package exercice5;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.text.DecimalFormat;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ServerProcess extends Thread {
	
	protected Socket sck;
	protected String cmd;
	protected String requestFile;
	
	public ServerProcess(Socket sck) {
		this.sck = sck;
	}
	
	protected void parse(String data){
		
		Pattern pattern = Pattern.compile("^([a-zA-Z]+) (/[0-9a-zA-Z\\.\\-/]*) (HTTP/[0-9\\.]+).*");
		Matcher m = pattern.matcher(data);
		boolean b = m.matches();
		if(b) { // Si on a trouvé
			this.cmd = m.group(1);
			this.requestFile = m.group(2);
		}
		else
			System.err.println("Entête incomprise");
	}
	
	@Override
	public void run() {
		try{
			System.out.println("Connexion établie");
			System.out.println("Ouverture d'un thread");
			// Un client s'est connecte, le serveur lit le message envoye par le le client (sans garantie de lire tout le message)
			byte[] bufI = new byte[2048];
			byte[] bufO = new byte[2048];
			byte[] bufF = new byte[2048];
			int lenBufI;
			int lenBufO;
			int lenBufF;
			
			InputStream inputStream = this.sck.getInputStream();
			lenBufI = inputStream.read(bufI);
			
			String inputData = new String(bufI, 0 , lenBufI);
			
			this.parse(inputData);
			System.out.println("Fichier demandé : " + this.requestFile);
			
			System.out.println("Fichier demandé = "+inputData);
			
			OutputStream outputStream = this.sck.getOutputStream();
			File file = new File(inputData);
			
			DecimalFormat df = new DecimalFormat("00000000");
			df.format(file.length());
			outputStream.write(df.format(file.length()).getBytes()); // On envoie la taille du fichier
			
			FileInputStream fis = new FileInputStream(file);
			lenBufF = fis.read(bufF);
			while (lenBufF != -1){
				//Thread.sleep(5000);
				outputStream.write(bufF, 0, lenBufF); // On envoie le contenu du fichier sur le reseau
				lenBufF = fis.read(bufF); // On remplis le buffer avec le fichier
			}
			
			fis.close(); // Ferme le fichier
			
			this.sck.close();
			System.out.println("Arret du thread");
		}
		catch (Exception e){
			System.err.println(e);
		}
	}
}
