package nim;

import java.rmi.AccessException;
import java.rmi.AlreadyBoundException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.Scanner;

public class UnProgrammeClient {
	public static void main(String[] args) throws AccessException,
			RemoteException, AlreadyBoundException, NotBoundException {
		// Il y a un registry sur le port 5050 sur votre machine
		Registry registry = LocateRegistry.getRegistry("127.0.0.1", 5050);
		// On récupére un stub qui nous permettra d'accéder au service
		Nim stub = (Nim) registry.lookup("remi");
		// On va maintenant pourvoir s'en servir pour faire un calcul
		System.out.println("--- NIM ---");
		Scanner sc = new Scanner(System.in);
		int tas;
		int allumettes;
		String[] game;
		String pseudo;
		int res;
		boolean error = true;
		
		System.out.println("Quel est votre pseudo ?");
		pseudo = sc.next();
		do{
			do{
				try {
					game =  stub.showGame();
					for (String line : game) {
						System.out.println(line);
					}
					System.out.print("Sur quel tas voulez vous prendre ? ");
					tas = sc.nextInt();
					System.out.print("\nCombien d'allumettes voulez vous enlever ? [1-3] ");
					allumettes = sc.nextInt();
					stub.jouer(tas, allumettes);
					error = false;
					
				} catch (NimException e) {
					System.out.println(e.getMessage());
					System.out.println("Veuillez rejouer");
				}
			}
			while (error);
		}
		while(true);
		
	}
}
