/**
 * Type énuméré pour les erreurs contextuelles.
 * Ce type énuméré définit toutes les erreurs contextuelles possibles et 
 * permet l'affichage des messages d'erreurs pour la passe 2.
 */

// -------------------------------------------------------------------------
// A COMPLETER, avec les différents types d'erreur et les messages d'erreurs 
// correspondants
// -------------------------------------------------------------------------

package ProjetCompil.Verif.Src;

public enum ErreurContext {
	ErreurVariableNonDeclaree,
	ErreurBorneNonEntier,
	ErreurBorneDefinitionIntervalleInverse,
	ErreurBorneDefinitionIntervalleVide,
	ErreurTypeNonDeclare,
	ErreurRedefinitionVariable,
	ErreurIdentificateurVarAttendu,
	ErreurAffectionIncompatible,
   ErreurNonRepertoriee;

   void leverErreurContext(String s, int numLigne) throws ErreurVerif {
      System.err.println("Erreur contextuelle : ");
      switch (this) {
      	case ErreurVariableNonDeclaree:
      		System.err.print("La variable " + s + " n'a pas été préalablement définie");
      	break;
      	case ErreurBorneNonEntier:
      		System.err.print("La borne utilisée (\"" + s + "\") n'est pas de type entier");
      	break;
      	case ErreurBorneDefinitionIntervalleInverse:
      		System.err.print("La borne inférieur est plus grande que la borne supérieur");
      	break;
      	case ErreurBorneDefinitionIntervalleVide:
      		System.err.print("La borne inférieur et la borne supérieur sont égales");
      	break;
      	case ErreurTypeNonDeclare:
      		System.err.print("Le type " + s + " n'a pas été préalablement définie");
      	break;
      	case ErreurRedefinitionVariable:
      		System.err.print("La variable " + s + " a déjà été définie");
      	break;
      	case ErreurIdentificateurVarAttendu:
      		System.err.print("Un nom de variable est attendus, \"" + s + "\" n'en n'est pas");
      	break;
      	case ErreurAffectionIncompatible:
      		System.err.print("La variable n'est pas compatible avec l'expression");
      	break;
      	
         default:
            System.err.print("non repertoriee");
      }
      System.err.println(" ... ligne " + numLigne);
      throw new ErreurVerif();
   }

}


