/**
 * Type énuméré pour les erreurs contextuelles.
 * Ce type énuméré définit toutes les erreurs contextuelles possibles et 
 * permet l'affichage des messages d'erreurs pour la passe 2.
 */

// -------------------------------------------------------------------------
// A COMPLETER, avec les différents types d'erreur et les messages d'erreurs 
// correspondants
// -------------------------------------------------------------------------

package ProjetCompil.Verif.Src;

public enum ErreurContext {
	ErreurVariableNonDeclaree,
	ErreurBorneNonEntier,
	ErreurBorneDefinitionIntervalleInverse,
	ErreurBorneDefinitionIntervalleVide,
	ErreurTypeNonDeclare,
	ErreurRedefinitionVariable,
	ErreurIdentificateurVarAttendu,
	ErreurAffectionIncompatible,
	ErreurOperationIncompatible,
	ErreurIdentificateurVarOuConstanteAttendu,
	ErreurPasFor,
	ErreurCondition,
	ErreurWrite,
	ErreurLecture,
   ErreurNonRepertoriee;

   void leverErreurContext(String s, int numLigne) throws ErreurVerif {
      System.err.println("Erreur contextuelle : ");
      switch (this) {
      	case ErreurVariableNonDeclaree:
      		System.err.print("La variable " + s + " n'a pas été préalablement définie");
      	break;
      	case ErreurBorneNonEntier:
      		System.err.print("La borne utilisée (\"" + s + "\") n'est pas de type entier");
      	break;
      	case ErreurBorneDefinitionIntervalleInverse:
      		System.err.print("La borne inférieur est plus grande que la borne supérieur");
      	break;
      	case ErreurBorneDefinitionIntervalleVide:
      		System.err.print("La borne inférieur et la borne supérieur sont égales");
      	break;
      	case ErreurTypeNonDeclare:
      		System.err.print("Le type " + s + " n'a pas été préalablement définie");
      	break;
      	case ErreurRedefinitionVariable:
      		System.err.print("La variable " + s + " a déjà été définie");
      	break;
      	case ErreurIdentificateurVarAttendu:
      		System.err.print("Un nom de variable est attendus, \"" + s + "\" n'en n'est pas");
      	break;
      	case ErreurAffectionIncompatible:
      		System.err.print("La variable n'est pas compatible avec l'expression");
      	break;
      	case ErreurOperationIncompatible:
      		System.err.print("L'operateur \""+ s +"\" n'est pas compatible avec les types de variable utilisés");
      	break;
      	case ErreurIdentificateurVarOuConstanteAttendu:
      		System.err.print("Un nom de variable ou une constante est attendus, \"" + s + "\" n'en n'est pas");
      	break;
      	case ErreurPasFor:
      		System.err.print("Le pas de la boucle for doit être un interval");
      	break;
      	case ErreurCondition:
      		System.err.print("La condition de l'instruction \"" + s + "\" doit être booléenne");
      	break;
      	case ErreurWrite:
      		System.err.print("L'instruction Write attends des expresssions de type Interval, Réel ou Chaine de caractère. Expression de type \""+s+"\" utilisée");
      	break;
      	case ErreurLecture:
      		System.err.print("L'instruction Read attends des expresssions de type Interval ou Réel. Expression de type \""+s+"\" utilisée");
      	break;
      	
         default:
            System.err.print("non repertoriee");
      }
      System.err.println(" ... ligne " + numLigne);
      throw new ErreurVerif();
   }

}


